import { world, system, ItemStack } from '@minecraft/server';
import { Vector3 } from 'common/math.js';
import { foodList } from 'food_fight/configs/food_list.js';

world.beforeEvents.itemUse.subscribe(ed =>{
	let player = ed.source;
	let item = ed.itemStack;
	system.run(() =>{
		throwFood(player, item)
	});
});

world.beforeEvents.itemUseOn.subscribe(e =>{
	let block = e.block;
	let player = e.source;
	let hand = player.getComponent('equippable');
	let item = hand.getEquipment('Mainhand');
	if(player.isSneaking && foodList.includes(item.typeId)){
		e.cancel = true;
	}
});

function throwFood(p, i){
	if(!foodList.includes(i.typeId)) return;
	if(!p.isSneaking) return;
	let strength = p.getEffect('strength') == undefined ? 2 : p.getEffect('strength').amplifier + 2;
	p.runCommand('gamerule sendcommandfeedback false');
	p.runCommand(`clear @s[m=!c] ${i.typeId} 0 1`);
	p.runCommand('gamerule sendcommandfeedback true');
	p.playSound('mob.witch.throw', p.location);
	let dimension = p.dimension;
	let { x:hx, y:hy, z:hz } = p.getHeadLocation();
	let { x:vx, y:vy, z:vz } = p.getViewDirection();
	let food = dimension.spawnEntity(`raigen:throw_${i.typeId.split(':')[1]}`, {x: hx + vx, y: hy + vy + 0.175, z: hz + vz});
	food.applyImpulse(Vector3.Multiply(p.getViewDirection(), {x:strength, y:strength, z:strength}));
}